/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * g-window.cc
 * Copyright (C) 2017 Unknown <francois@gautrais.eu>
 *
 * histodexc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * histodexc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "main.h"
#include <config.h>
#include <gtk/gtk.h>


#include <glib/gi18n.h>
#include "g-window.h"

#include "general-tab.h"
#include "resource-tab.h"
#include "stage-tab.h"
#include "zone-tab.h"
#include "merkator.h"
#include <fstream>
#include "generator.h"
#include "utils.h"

GWindow* gw=NULL;

typedef struct _Private Private;
struct _Private
{
	/* ANJUTA: Widgets declaration for histodexc.ui - DO NOT REMOVE */
};



GWindow::GWindow(const std::string& file)
{
	setlocale(LC_NUMERIC, "C");
	m_magic=1234;
	#if !defined(TEST) && defined(G_OS_WIN32)
	gchar *prefix = g_win32_get_package_installation_directory_of_module (NULL);
	gchar *datadir = g_build_filename (prefix, "share", PACKAGE, NULL);
	gchar *ui_file = g_build_filename (datadir, "ui", file.c_str(), NULL);
	#endif

	GError* error = NULL;

	/* Load UI from file */
	m_builder = gtk_builder_new ();
	if (!gtk_builder_add_from_file (m_builder, file.c_str (), &error))
	{
		g_critical ("Couldn't load builder file: %s", error->message);
		g_error_free (error);
	}

	/* Auto-connect signal handlers */
	gtk_builder_connect_signals (m_builder, NULL);

	/* Get the window object from the ui file */
	m_window = GTK_WIDGET (gtk_builder_get_object (m_builder, TOP_WINDOW));
	printf("1 M_WINDOWS: %d\n",  m_window);
        if (!m_window)
        {
                g_critical ("Widget \"%s\" is missing in file %s.",
				TOP_WINDOW,
				file.c_str());
        }

	m_priv = (Private*) g_malloc (sizeof (struct _Private));
	/* ANJUTA: Widgets initialization for histodexc.ui - DO NOT REMOVE */
	

	/*#if !defined(TEST) && defined(G_OS_WIN32)
		g_free (prefix);
		g_free (datadir);
		g_free (ui_file);
	#endif*/
	gw=this;
}

GWindow::~GWindow()
{
	g_object_unref (m_builder);
	g_free (m_priv);
}


