/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * window-advanced.h
 * Copyright (C) 2017 Unknown <francois@gautrais.eu>
 *
 * histodexc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * histodexc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _WINDOW_ADVANCED_H_
#define _WINDOW_ADVANCED_H_
#include "g-window.h"
class GeneralTab;
class ResourceTab;
class ZoneTab;
class StageTab;
class WindowAdvanced: public GWindow 
{
public:
	WindowAdvanced(const std::string& file);
	virtual ~WindowAdvanced();
	 
	virtual void show();
	virtual void write(const std::string& file);
	virtual Json::Value getJson(bool genFinal=false);
	virtual void on_generate();
	virtual void on_new();
	virtual void on_import();
	virtual void on_open();
	virtual void on_save();
	virtual void on_saveas();
	virtual void on_exit();
	virtual void open(const std::string& f);
	virtual void changeFile(const std::string& file);
protected:
	GeneralTab		*m_general;
	ResourceTab		*m_resource;
	ZoneTab			*m_zone;
	StageTab		*m_stage;
	std::string     m_currentFile;
private:
	virtual void init_menu();
	virtual void setModidified();

	virtual void clearModidified();
	virtual bool isModidified();
	virtual bool checkSaved();

};

#endif // _WINDOW_ADVANCED_H_

